﻿//向页面注入JS
function injectCustomJs(jsPath) {
	var temp = document.createElement('script');
	temp.setAttribute('type', 'text/javascript');
	// 获得的地址类似：chrome-extension://ihcokhadfjfchaeagdoclpnjdiokfakg/js/inject.js
	temp.src = chrome.runtime.getURL(jsPath);
	temp.onload = function () {
		// 放在页面不好看，执行完后移除掉
		this.parentNode.removeChild(this);
	};
	document.body.appendChild(temp);
}
//直接提交表单
window.addEventListener("message", function (e) {
	if (!e.data) {
		return;
	}

	const items = ['1688', 'tmall', 'taobao', 'jd'];
	if (!items.includes(e.data.cmd)) {
		return;
	}

	chrome.runtime.sendMessage('get-beahu-auth', (response) => {
		const beahuAuth = response;

		if (beahuAuth === null) {
			jQuery('#beahu-notice').html('未登录 beahu，<a href="https://app.beahu.com" target="_blank">点击登录</a>');
			setTimeout(function () {
				jQuery('#beahu-notice').remove();
			}, 5000)
			return;
		}

		jQuery('#beahu-notice').html('抓取成功，上传中...');

		var body = e.data.data.body;
		var data = {
			platform: e.data.cmd,
			url: e.data.data.href,
			body: body
		};

		$.ajax({
			type: "POST",
			url: "https://app.beahu.com/api/v2/products/crawls",
			headers: { token: beahuAuth.token },
			data: JSON.stringify(data),
			dataType: "json",
			contentType: 'application/json',
			success: function (data) {
				jQuery('#beahu-notice').html('上传成功，请登录 beahu 后台查看');
			},
			error: function (res) {
				jQuery('#beahu-notice').html(res.responseJSON.message || '网络链接错误');
			},
			complete: function (res) {
				setTimeout(function () {
					jQuery('#beahu-notice').remove();
				}, 5000)
			}
		})

	});
}, false);

//监听background的消息
chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
	if (request.greeting == "clickMenu") {
		const host = location.host;
		const hosts = ['detail.1688.com', 'detail.tmall.com', 'item.taobao.com', 'item.jd.com'];

		if (hosts.includes(host)) {
			injectCustomJs('js/jquery-3.6.0.js');

			setTimeout(() => {
				injectCustomJs('js/inject.js');
			},100)
		} else {
			alert(location.host + "不支持的网页")
		}
	}
});

